package com.nisum.app.fluxandmono;

import org.junit.jupiter.api.Test;
import reactor.core.publisher.Flux;
import reactor.test.StepVerifier;

public class FluxAndMonoUnitTest {


    /*//test case1- pass- to check whether data emit by flux is in correct order
    @Test
    public void testFluxElements_WithoutError(){

        Flux<String> stringFlux=Flux.just("Spring","SpringBoot","Reactive Spring")
                .log();

        StepVerifier.create(stringFlux).expectNext("Spring")
                .expectNext("SpringBoot")
                .expectNext("Reactive Spring")
                .verifyComplete();

    }
}*/

    //test case2- fail- to check whether data emit by flux is in incorrect order
    /*@Test
    public void testFluxElements_WithoutError(){

        Flux<String> stringFlux=Flux.just("Spring","SpringBoot","Reactive Spring")
                .log();

        StepVerifier.create(stringFlux)
                .expectNext("Reactive Spring")
                .expectNext("Spring")
                .expectNext("SpringBoot")
                .verifyComplete();

    }*/


    // checking for onError complete case
    /*@Test
    public void testFluxElementsCount_WithError(){

        Flux<String> stringFlux=Flux.just("Spring","SpringBoot","Reactive Spring")
                .concatWith(Flux.error(new RuntimeException("Error Occur")))
                .log();

        StepVerifier.create(stringFlux)
                .expectNext("Spring")
                .expectNext("SpringBoot")
                .expectNext("Reactive Spring")
                .expectError(RuntimeException.class)
                .verify();

    }*/

    /*// check count of elements emitting by flux instead of value
    @Test
    public void testFluxElementsCount_WithError(){

        Flux<String> stringFlux=Flux.just("Spring","SpringBoot","Reactive Spring")
                .concatWith(Flux.error(new RuntimeException("Error Occured")))
                .log();

        StepVerifier.create(stringFlux)
                .expectNextCount(3)
                .expectErrorMessage("Error Occured")
                .verify();

    }*/

    // we can check by passing all value as one in expectNext()
    @Test
    public void testFluxElementsCount_WithError(){

        Flux<String> stringFlux=Flux.just("Spring","SpringBoot","Reactive Spring")
                .concatWith(Flux.error(new RuntimeException("Error Occured")))
                .log();

        StepVerifier.create(stringFlux)
                .expectNext("Spring","SpringBoot","Reactive Spring")
                .expectErrorMessage("Error Occured")
                .verify();

    }
}
